<template lang="pug">
section.section.partners-section
  .section__inner.partners-section__inner
    .container
      .section-heading.partners-section__heading
        h2.section-heading__title.section-heading__title--large.partners-section__title(
          v-if="title || (linkUrl && linkCaption)"
        )
          p(v-if="title") {{ title }}
          .scrollto.partners-section__scroll-link(
            v-if="linkUrl && linkScroll && linkCaption"
            @click.prevent="scrollTo(linkUrl)"
          ) {{ linkCaption }}
          a.scrollto.partners-section__scroll-link(
            v-else-if="linkUrl && linkCaption && (linkUrl.indexOf('http') === 0 || linkUrl.indexOf('#') === 0)"
            :href="linkUrl"
          ) {{ linkCaption }}
          nuxt-link.scrollto.partners-section__scroll-link(
            v-else-if="linkUrl && linkCaption"
            :to="linkUrl"
          ) {{ linkCaption }}

      .partners-section__list(v-if="content" v-html="content")

      .partners-section__small-text(v-if="footnote" v-html="footnote")

      button.btn(
        v-if="buttonCaption"
        type="button"
        @click="$emit('showModal')"
      ) {{ buttonCaption }}

      .partners-section__img(
        v-if="image"
        v-observe-visibility="visibilityChanged"
      )
        img(:src="image" alt="")
        .partners-section__img-crop
</template>

<script>
import objectFitImages from 'object-fit-images'
import { visibilityMixin } from '../../../mixins/visibility'
import smoothscroll from 'smoothscroll-polyfill'

export default {
  name: 'PartnersSection',

  methods: {
    scrollTo (blockId) {
      if (blockId.indexOf('#') === 0) {
        blockId = blockId.substr(1)
      }
      const el = document.getElementById(blockId)
      if (el) {
        el.scrollIntoView({ block: 'start', behavior: 'smooth' })
      }
    }
  },

  mounted () {
    objectFitImages()
    smoothscroll.polyfill()
  },

  mixins: [visibilityMixin],

  props: {
    buttonCaption: {
      type: [String, null],
      required: false,
      default: null
    },
    content: {
      type: [String, null],
      required: false,
      default: null
    },
    footnote: {
      type: [String, null],
      required: false,
      default: null
    },
    image: {
      type: [String, null],
      required: false,
      default: null
    },
    linkCaption: {
      type: [String, null],
      required: false,
      default: null
    },
    linkScroll: {
      type: Boolean,
      required: false,
      default: false
    },
    linkUrl: {
      type: [String, null],
      required: false,
      default: null
    },
    title: {
      type: [String, null],
      required: false,
      default: null
    }
  }
}
</script>
